﻿Imports Telerik.Web.UI.Widgets
Imports Telerik.Web.UI

Partial Class Default_Vb
	Inherits System.Web.UI.Page
	Protected Sub Page_Load(ByVal sender As Object, ByVal e As EventArgs) Handles Me.Load
		If Not IsPostBack Then
			RadFileExplorer1.Configuration.ContentProviderTypeName = GetType(CustomColumnsContentProvider).AssemblyQualifiedName
			Dim paths As String() = New String() {"~/Products"}
			RadFileExplorer1.Configuration.ViewPaths = paths
			RadFileExplorer1.Configuration.UploadPaths = paths
			RadFileExplorer1.Configuration.DeletePaths = paths
		End If
		AddThumbnailColumn()
	End Sub

	Private Sub AddGridColumn(ByVal name As String, ByVal uniqueName As String, ByVal sortable As Boolean)
		RemoveGridColumn(uniqueName)
		Dim gridTemplateColumn1 As New GridTemplateColumn()
		gridTemplateColumn1.HeaderText = name
		If sortable Then
			gridTemplateColumn1.SortExpression = uniqueName
		End If
		gridTemplateColumn1.UniqueName = uniqueName
		gridTemplateColumn1.DataField = uniqueName
		RadFileExplorer1.Grid.Columns.Add(gridTemplateColumn1)
	End Sub
	Private Sub RemoveGridColumn(ByVal uniqueName As String)
		If Not [Object].Equals(RadFileExplorer1.Grid.Columns.FindByUniqueNameSafe(uniqueName), Nothing) Then
			RadFileExplorer1.Grid.Columns.Remove(RadFileExplorer1.Grid.Columns.FindByUniqueNameSafe(uniqueName))
		End If
	End Sub

	Private Sub AddThumbnailColumn()
		AddGridColumn("Thumb", "Thumb", False)
	End Sub

	Public Class CustomColumnsContentProvider
		Inherits Telerik.Web.UI.Widgets.FileSystemContentProvider
		Public Sub New(ByVal context As HttpContext, ByVal searchPatterns As String(), ByVal viewPaths As String(), ByVal uploadPaths As String(), ByVal deletePaths As String(), ByVal selectedUrl As String, _
		 ByVal selectedItemTag As String)
			MyBase.New(context, searchPatterns, viewPaths, uploadPaths, deletePaths, selectedUrl, _
			 selectedItemTag)
		End Sub

		Public Overloads Overrides Function ResolveDirectory(ByVal path As String) As DirectoryItem
			Dim oldItem As DirectoryItem = MyBase.ResolveDirectory(path)
			For Each fileItem As FileItem In oldItem.Files
				Dim imageExtensios As String() = New String() {".jpg", ".gif", ".png"}
				' Images extensios
				If Array.IndexOf(imageExtensios, fileItem.Extension) >= 0 Then
					'Show thumbnails for images only
					Dim pathToFile As String = fileItem.Location
					Dim htmlText As String = ("<img src='" & pathToFile & "' alt='") + fileItem.Name & "' class='thumbImages'/>"
					fileItem.Attributes.Add("Thumb", htmlText)
				End If
			Next
			Return oldItem
		End Function
	End Class

End Class
